import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class StreamViewController extends StatelessWidget {
  final dynamic initialData;
  final Stream stream;
  final AsyncWidgetBuilder builder;

  StreamViewController({
    this.initialData,
    @required this.stream,
    @required this.builder
  });

  @override
  Widget build(BuildContext context) {
    return StreamBuilder(
        initialData: initialData,
        stream: stream,
        builder:
            (BuildContext context, AsyncSnapshot snapshot) {
          if (initialData != null) {
            return builder(context, snapshot);
          } else {
            switch (snapshot.connectionState) {
              case ConnectionState.waiting:
                return Center(child: CircularProgressIndicator());
              default:
                return builder(context, snapshot);
            }
          }
        });
  }
}