import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

class ButtonView extends StatelessWidget {
  final String text;
  final Function onPressed;
  final Color color;
  final Color contentColor;
  final IconData iconData;

  ButtonView({
    this.text,
    this.onPressed,
    this.color,
    this.contentColor,
    this.iconData
  });

  @override
  Widget build(BuildContext context) {
    final Color accentIconColor =  Theme.of(context).accentIconTheme.color;

    final Color accentColor = Theme.of(context).accentColor;

    return ButtonTheme(
      height: kIsWeb ? 45.0 : 35.0,
      child: RaisedButton.icon(
          materialTapTargetSize: MaterialTapTargetSize.shrinkWrap,
          icon: iconData != null ? Icon(iconData, color: contentColor ?? accentIconColor) : Container(),
          onPressed: onPressed,
          disabledColor: Colors.grey,
          label: Text(
              text,
              style: TextStyle(
                color: contentColor ?? accentIconColor,
                fontSize: 16.0
              )
          ),
          color: color ?? accentColor,
          shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(6))
      ),
    );
  }
}
