import 'package:flutter/material.dart';

class ExpansionPanelView extends StatefulWidget {
  final String text;
  final Widget child;
  final Widget icon;

  ExpansionPanelView({
    this.text,
    this.child,
    this.icon
  });

  @override
  _ExpansionPanelViewState createState() => _ExpansionPanelViewState();
}

class _ExpansionPanelViewState extends State<ExpansionPanelView> {
  bool _isExpanded = false;

  @override
  Widget build(BuildContext context) {
    return ExpansionPanelList(
      expansionCallback: (int index, bool isExpanded) {
        setState(() {
          _isExpanded = !_isExpanded;
        });
      },
      children: [
        ExpansionPanel(canTapOnHeader: true, isExpanded: _isExpanded, headerBuilder: (context, isExpanded) {
          return ListTile(
            leading: widget.icon,
            title: Text(widget.text),
          );
        }, body: widget.child)
      ],
    );
  }
}
