import 'package:flutter/material.dart';

class PopUpStringView extends StatefulWidget {
  final List<String> values;
  final Function onSelected;
  final Widget child;

  PopUpStringView({
    this.values,
    this.onSelected,
    this.child
  });

  @override
  _PopUpStringViewState createState() => _PopUpStringViewState();
}

class _PopUpStringViewState extends State<PopUpStringView> {
  @override
  Widget build(BuildContext context) {
    return PopupMenuButton<String>(
      child: widget.child,
      onSelected: (String value) {
        widget.onSelected(value);
      },
      itemBuilder: (BuildContext context) => (widget.values ?? []).map<PopupMenuEntry<String>>((String value) {
        return value == "" ? PopupMenuDivider() : PopupMenuItem<String>(
          value: value,
          child: Text(value),
        );
      }).toList(),
    );
  }
}